//+------------------------------------------------------------------+
//|                                                     Snapshot.mq4 |
//|                                        Copyright 2018, Artur Zas |
//|                                         https://www.az-invest.eu |
//+------------------------------------------------------------------+
#property copyright "Copyright 2018, Artur Zas"
#property link      "https://www.az-invest.eu"
#property version   "1.00"
#property strict

#include <stderror.mqh> 
#include <stdlib.mqh> 

input string InpImageWebfolder   = "IIS image webfolder";   // IIS image webfolder symlink
input int    InpSaveInterval     = 3600;                    // Save new image every x seconds
input int    InpWidth            = 2048;                    // Width of image in pixels
input int    InpHeight           = 1536;                    // Height of image in pixels

//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
{
   IsNewHour(true);
   return(INIT_SUCCEEDED);
}
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
{
}
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
{
   if(!IsNewHour(false))
      return;

   string fileName = StringFormat("%s\\%s%d.png", InpImageWebfolder, _Symbol, _Period);
   
   if(!ChartScreenShot(0,fileName,InpWidth,InpHeight))
   {
      string err = StringFormat("Error saving screenshot of %s(%d) chart - %s",_Symbol,_Period,ErrorDescription(GetLastError()));
      Alert(err);
   }
   else
   {
      PrintFormat("Saved screenshot to %s",fileName);
   }
}
//+------------------------------------------------------------------+

bool IsNewHour(bool reset)
{
   static datetime last = 0;
   
   if(reset)
   {
      last = 0;
      return false;
   }
   
   if(last == 0)
   {
      last = TimeCurrent();
      return true;
   }

   datetime current = TimeCurrent();
   if(current - last > 3600)
   {
      last = current;
      return true;
   }

   return false;
}
